<?php
/**
 * 注：views目录中的文件，由前端同学负责维护与更新，PHP同学负责将此目录与php项目工程中的views目录保持同步即可
 * @todo 
 */

date_default_timezone_set('PRC');

if(!defined('VIEW_DIR')){
  define('VIEW_DIR', dirname(__FILE__) . '/views');
}

if(!defined('LOCAL_DEBUG')){// 是否为本地测试环境
  define('LOCAL_DEBUG', true);
}

require '../vendor/autoload.php';

$app = new \Slim\Slim(array(
  'view' => new \Slim\Views\Smarty(),
  'templates.path' => VIEW_DIR
));

$view = $app->view();
$view->parserDirectory = dirname(__FILE__) . '/../vendor/smarty';
$view->parserCompileDirectory = dirname(__FILE__) . '/../vendor/smarty_tmp/templates_c';
$view->parserCacheDirectory = dirname(__FILE__) . '/../vendor/smarty_tmp/cache';

// get manifest
$manifest = VIEW_DIR . '/ver.json';
$manijson = json_decode(trim(file_get_contents($manifest), chr(239).chr(187).chr(191)), true);

// 按照是否为测试环境，获取版本控制信息
// php开发同学可直接设置LOCAL_DEBUG为false
function getOutVer(){
  global $manijson;

  $ret = array();

  if(LOCAL_DEBUG){
    $ret['prefix'] = '/static';
    $ret['vers'] = array();
    foreach ($manijson as $file => $ver) {
      $a = strrpos($ver, '.');
      $b = strrpos($ver, '-');
      $str = substr($ver, 0,$b) . substr($ver, $a);//去除文件版本号
      $ret['vers'][$file] = $str;
    }
  }
  else{
    $ret['prefix'] = '';
    $ret['vers'] = $manijson;
  }

  return $ret;
}


$app->get('/', function() use ($app){
  echo 'welcome~';
});

// 特价团首页
$app->get('/index', function () use ($app){
  $out = require 'mock/demo/index.php';
  $out = array_merge($out, getOutVer());
  
  $app->render('index.tpl', array('out' => $out));
});

$app->run();