﻿#<%=name%>

##开发环境准备
* 网络环境
  内网
* node
  v4.2.4
* tnpm——[tencent npm](http://tnpm.oa.com/)

  ```
  npm install @tencent/tnpm -g --registry=http://r.tnpm.oa.com --proxy=http://p.tnpm.oa.com:80 --verbose
  ```

* php
  v5.4.0及其以上版本 [win](http://windows.php.net/downloads/releases/archives/) [mac](http://php.net/manual/zh/install.macosx.php)

##项目目录说明
* [不可编辑]css/fonts/                 中间生成的字体文件
* [不可编辑]css/inc/                   中间生成的待import的文件
* [可以编辑]css/slices/                icon用到的切图或者iconfont用到的svg
* [不可编辑]css/sprite/                中间生成的雪碧图
* [可以编辑]css/style.css              原始样式文件

* [可以编辑]php/htdocs/mock/           模版所需的测试数据
* [不可编辑]php/htdocs/static/css/     临时生成的样式文件
* [不可编辑]php/htdocs/static/js/      临时生成的js文件
* [可以编辑]php/htdocs/static/images/  临时生成的图片文件
* [可以编辑]php/htdocs/svn/            对应php工程中的views svn目录(通过svn checkout)
* [可以编辑]php/htdocs/views/          模板文件
* [可以编辑]php/htdocs/views/index.php 路由与模版对应关系
* [不可编辑]php/vendor                 库文件
* [不可编辑]php/composer.json          工程文件
* [不可编辑]php/composer.lock          工程文件

* [不可编辑]release/                   存放将要上线的文件

* [可编辑]其他

##开发
* `npm run server`: 启动本地服务器(php build-in server + slim + smarty, 命令内容的域名如有需要, 需配置hosts)
* `npm run build:w`: 自动构建项目，并监听文件改动，用于开发过程中
* `npm run nproxy`: 用于开发过程中，将网络文件请求指向到本地（新增规则见gulpfile中nproxy任务）
* `npm run release`: 生成项目发布版
* `npm run deploy`: 对服务端代码远程部署(注意需要对部署目录循环设置写权限)
* `npm run upload`: 上传项目（注意修改gulpfile中upload任务中的版本号）

##版本控制
在执行`npm run release`之后，项目根目录下会自动生成一个`rev-manifest.json`文件，将文件拷贝到后端相关目录
```
// php相关代码
$manifest = ROOT_PATH . 'configs/rev-manifest.json';
$manijson = json_decode(file_get_contents($manifest), TRUE);// 注意去BOM

$out = array(
        "vers" => $manijson
    );
// smarty相关代码
$smarty->assign('out', $out);
$smarty->display('index.tpl', $out);

// index.tpl
<link type = "text/css" rel="stylesheet" href = "css/{$out.vers.page_css}" />
```

##参考
* manifest.json
https://github.com/sindresorhus/gulp-rev/blob/master/integration.md
* webpack optimization
https://github.com/webpack/docs/wiki/optimization
* php 5.4.0 支持Built-in web server，安装php之后即可提供一个web server。php build-in web server跟apache使用的不是同一个php.ini，可能会出现apache容器不会出现的问题
* slim框架只能用2.0版本，3.0版本不支持smarty
* smarty 2.6.30以上, 2.6.26报错

##推荐包
* @tencent/tcomjs //使用tnpm安装，常用工具类
* @tencent/tcomless //使用tnpm安装，常用css
* animate.css //动画库
* async //异步流程控制库
* watchjs // 对象属性监控组件
* RainbowVis-JS // 给定两端色值，制造100个以内的渐变颜色数组





